const { gql } = require('apollo-server');

module.exports = gql`
	type Role {
		name: String!
		desc: String!

		id: ID!
		createdAt: String!
	}
	type User {
		email: String!
		token: String!
		password: String!
		username: String!
		role: Role

		id: ID
		createdAt: String!
	}
	input RegisterInput {
		username: String!
		password: String!
		confirmPassword: String!
		email: String!
	}
	type Query {
		users: [User]
		user(itemId: ID): User
		roles: [Role]
		role(itemId: ID): Role
	}
	type Mutation {
		register(registerInput: RegisterInput): User!
		login(username: String!, password: String!): User!

		deleteUser(itemId: ID!): String!
		updateUser(
			id: ID,
			username: String!,
			email: String!,
			password: String!,
			role: ID,
		): String!

		deleteRole(itemId: ID!): String!
		updateRole(
			id: ID,
			name: String!,
			desc: String!
		): String!
    }
`;
